#include <windowsx.h>
#include <mmsystem.h>
#include <math.h>
#include <float.h>

/* DirectX headers */
#include "d:\mssdk\include\ddraw.h"
DDSURFACEDESC2 ddsd; 

/* Opcode definition */
#include "ops.h"

/* Prototypes */
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ROM(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK GPR_REGS(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CP0_REGS(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK FPR_REGS(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK COMMANDS(HWND, UINT, WPARAM, LPARAM);

BOOL SHOW_IPS;
DWORD START_TIME;
DWORD FINISH_TIME;
_int64 Counter;
_int64 ips;
_int32 seconds;
static HWND CommandsPCHandle=NULL;
void WriteMemory(_int64 vaddr, _int8 value, HWND hWnd);
inline _int8 ReadMemory(unsigned _int64 vaddr, HWND hWnd);
BOOL OpenRom(char szFileName[MAX_PATH]);
int Translate(void);
void UpdateRegs(void);
int Step(void);
void UpdateCommands();
char * AddOp();
char * AddGPR(int);
char * AddCP0(int);

struct OpCode
{
	unsigned op : 6;
	unsigned rs : 5;
	unsigned rt : 5;
	unsigned immediate : 16;
	unsigned target : 26;
	unsigned rd : 5;
	unsigned sa : 5;
	unsigned funct : 6;
	unsigned code : 14;
	unsigned codea : 10;
	unsigned codeb : 11;
};

OpCode Ops;
OpCode debug;
/* Ultra 64 globals */
unsigned _int64 z;
unsigned _int64 q;
BOOL Delay=0; // Used for delay slot
_int8 ManufacturerCode; // ROM Manufacturer ID
char Manufacturer[40]; // ROM Manufacturer Name
_int8 CountryCode; // ROM Country ID
char Country[40]; // ROM Country Name
BOOL N64isRunning=0;
BOOL STOP_OP=TRUE; // Stop on unhandled opcodes
HANDLE RomHandle; // Handle of the ROM file
BOOL SHOW=0; // Show current instruction number
char ROMName[20]; // Store ROM name
char text[80];
char textt[80];
char space[80];
DWORD dwRead;
HWND hList=NULL;
HWND hWndMain;
DWORD dwChildId;
HDC hDC;
unsigned _int16 byteswap;
BOOL BS;
BOOL copying;
unsigned _int32 x;
unsigned char two[1];
unsigned char four[3];
unsigned char fore[4];
unsigned char eight[7];
unsigned char opcode[4];
_int32 Instruction;
char OC[10]; // Stores mnemonic of opcode
char title[MAX_PATH+21]="Ultra 64";
_int8 huh;
DWORD dwSize;
char command[255];
LPCTSTR lpszTitle="Ultra 64";
#include "register.h"
#include "excption.h"
#include "memory.h"
#include "interupt.h"
#include "cpu.h"
#include "trans.h"
#define ScrollPC	(int)((PC - OldPC)>>2)
static HWND hCommandList=NULL;
static HWND hCommandScroll=NULL;
#include "debug.h"
BOOL NOT_OPEN_ROM=TRUE;
BOOL DISPLAY_HEADER=FALSE;
char program_counter[30];
char byte_swapped[15];
			


//
static HWND GPR0Handle=NULL;
static HWND GPR1Handle=NULL;
static HWND GPR2Handle=NULL;
static HWND GPR3Handle=NULL;
static HWND GPR4Handle=NULL;
static HWND GPR5Handle=NULL;
static HWND GPR6Handle=NULL;
static HWND GPR7Handle=NULL;
static HWND GPR8Handle=NULL;
static HWND GPR9Handle=NULL;
static HWND GPR10Handle=NULL;
static HWND GPR11Handle=NULL;
static HWND GPR12Handle=NULL;
static HWND GPR13Handle=NULL;
static HWND GPR14Handle=NULL;
static HWND GPR15Handle=NULL;
static HWND GPR16Handle=NULL;
static HWND GPR17Handle=NULL;
static HWND GPR18Handle=NULL;
static HWND GPR19Handle=NULL;
static HWND GPR20Handle=NULL;
static HWND GPR21Handle=NULL;
static HWND GPR22Handle=NULL;
static HWND GPR23Handle=NULL;
static HWND GPR24Handle=NULL;
static HWND GPR25Handle=NULL;
static HWND GPR26Handle=NULL;
static HWND GPR27Handle=NULL;
static HWND GPR28Handle=NULL;
static HWND GPR29Handle=NULL;
static HWND GPR30Handle=NULL;
static HWND GPR31Handle=NULL;
static HWND GPRPCHandle=NULL;
static HWND GPROCHandle=NULL;

static HWND CP00Handle=NULL;
static HWND CP01Handle=NULL;
static HWND CP02Handle=NULL;
static HWND CP03Handle=NULL;
static HWND CP04Handle=NULL;
static HWND CP05Handle=NULL;
static HWND CP06Handle=NULL;
static HWND CP07Handle=NULL;
static HWND CP08Handle=NULL;
static HWND CP09Handle=NULL;
static HWND CP010Handle=NULL;
static HWND CP011Handle=NULL;
static HWND CP012Handle=NULL;
static HWND CP013Handle=NULL;
static HWND CP014Handle=NULL;
static HWND CP015Handle=NULL;
static HWND CP016Handle=NULL;
static HWND CP017Handle=NULL;
static HWND CP018Handle=NULL;
static HWND CP019Handle=NULL;
static HWND CP020Handle=NULL;
static HWND CP021Handle=NULL;
static HWND CP022Handle=NULL;
static HWND CP023Handle=NULL;
static HWND CP024Handle=NULL;
static HWND CP025Handle=NULL;
static HWND CP026Handle=NULL;
static HWND CP027Handle=NULL;
static HWND CP028Handle=NULL;
static HWND CP029Handle=NULL;
static HWND CP030Handle=NULL;
static HWND CP031Handle=NULL;
static HWND CP0PCHandle=NULL;

static HWND FPR0Handle=NULL;
static HWND FPR1Handle=NULL;
static HWND FPR2Handle=NULL;
static HWND FPR3Handle=NULL;
static HWND FPR4Handle=NULL;
static HWND FPR5Handle=NULL;
static HWND FPR6Handle=NULL;
static HWND FPR7Handle=NULL;
static HWND FPR8Handle=NULL;
static HWND FPR9Handle=NULL;
static HWND FPR10Handle=NULL;
static HWND FPR11Handle=NULL;
static HWND FPR12Handle=NULL;
static HWND FPR13Handle=NULL;
static HWND FPR14Handle=NULL;
static HWND FPR15Handle=NULL;
static HWND FPR16Handle=NULL;
static HWND FPR17Handle=NULL;
static HWND FPR18Handle=NULL;
static HWND FPR19Handle=NULL;
static HWND FPR20Handle=NULL;
static HWND FPR21Handle=NULL;
static HWND FPR22Handle=NULL;
static HWND FPR23Handle=NULL;
static HWND FPR24Handle=NULL;
static HWND FPR25Handle=NULL;
static HWND FPR26Handle=NULL;
static HWND FPR27Handle=NULL;
static HWND FPR28Handle=NULL;
static HWND FPR29Handle=NULL;
static HWND FPR30Handle=NULL;
static HWND FPR31Handle=NULL;
static HWND FPRPCHandle=NULL;


